export declare type FluxType = string;
export declare type FSA<Payload = void> = {
    readonly type: FluxType;
    payload: Payload;
    error?: boolean;
    meta?: any;
};
export declare type Options = {
    namespace?: string;
    error?: boolean;
    meta?: any;
};
export declare type ActionCreator<Payload = void> = {
    type: FluxType;
    (payload: Payload, options?: Options): FSA<Payload>;
} & (Payload extends void ? {
    (payload?: Payload, options?: Options): FSA<Payload>;
} : {});
export declare function actionCreator<Payload = void>(type: FluxType): ActionCreator<Payload>;
declare const debugSettings: {
    doNotUseSamePrefix: boolean;
    doNotCreateSameFluxType: boolean;
    logPrefix: boolean;
    logFluxType: boolean;
};
export declare function debugSetting(settings: typeof debugSettings): void;
export declare function actionCreatorFactory(prefix?: string): <Payload = void>(type: string) => ActionCreator<Payload>;
export {};
