"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function actionCreator(type) {
    return Object.assign(function (payload, options) {
        return {
            type: options && options.namespace ? options.namespace + "/" + type : type,
            payload: payload,
            error: options && options.error,
            meta: options && options.meta
        };
    }, {
        type: type
    });
}
exports.actionCreator = actionCreator;
var debugSettings = {
    doNotUseSamePrefix: false,
    doNotCreateSameFluxType: false,
    logPrefix: false,
    logFluxType: false,
};
var cachedPrefixList = [];
var cachedFluxTypeList = [];
function debugSetting(settings) {
    Object.assign(debugSettings, settings);
}
exports.debugSetting = debugSetting;
function actionCreatorFactory(prefix) {
    if (prefix && debugSettings.doNotUseSamePrefix) {
        if (cachedPrefixList.includes(prefix)) {
            throw Error("Prefix [" + prefix + "] is already used.");
        }
        cachedPrefixList.push(prefix);
    }
    if (debugSettings.logPrefix) {
        console.log("Success to used prefix! That is [" + prefix + "].");
    }
    return function (type) {
        var base = prefix ? prefix + "/" + type : type;
        if (debugSettings.doNotCreateSameFluxType) {
            if (cachedFluxTypeList.includes(base)) {
                throw Error("FluxType [" + base + "] is already used.");
            }
            cachedFluxTypeList.push(base);
        }
        if (debugSettings.logFluxType) {
            console.log("Success to used FluxType! That is [" + base + "].");
        }
        return Object.assign(function (payload, options) {
            return {
                type: options && options.namespace ? options.namespace + "/" + base : base,
                payload: payload,
                error: options && options.error,
                meta: options && options.meta
            };
        }, {
            type: base,
        });
    };
}
exports.actionCreatorFactory = actionCreatorFactory;
