import { ActionContext, ActionTree, MutationTree, Store } from "vuex";
import { FSA, ActionCreator } from "./action-creator";
export declare type PayloadType<T> = T extends ActionCreator<infer R> ? R : never;
export declare type ReturnType<T> = T extends (...args: any[]) => infer R ? R : never;
export declare type ActionHandler<S, R, P> = (this: Store<R>, injectee: ActionContext<S, R>, payload: P) => any;
export declare type ActionObject<S, R, P> = {
    root?: boolean;
    handler: ActionHandler<S, R, P>;
};
export declare type Action<S, R, P> = ActionHandler<S, R, P> | ActionObject<S, R, P>;
export declare type Mutation<S, P> = (this: Store<S>, state: S, payload: P) => void;
export declare function action<S, R, A extends ActionCreator<any>>(actionCreator: A, action: Action<S, R, FSA<PayloadType<A>>>): ActionTree<S, R>;
export declare function mutation<S, A extends ActionCreator<any>>(actionCreator: A, mutation: Mutation<S, FSA<PayloadType<A>>>): MutationTree<S>;
export declare function combineAction<S, R>(...actions: ActionTree<S, R>[]): ActionTree<S, R>;
export declare function combineMutation<S>(...mutations: MutationTree<S>[]): MutationTree<S>;
